com.amazonaws.codegen.model.config.customization

## Class CustomizationConfig

- java.lang.Object
- - com.amazonaws.codegen.model.config.customization.CustomizationConfig

    public class CustomizationConfig
    extends Object

### Field Summary

Fields
`static CustomizationConfig` `DEFAULT`

### Method Summary

All Methods Instance Methods Concrete Methods
`Map<String,ConstructorFormsWrapper>` `getAdditionalShapeConstructors()`
`AuthPolicyActions` `getAuthPolicyActions()`
`List<ConvenienceTypeOverload>` `getConvenienceTypeOverloads()` Only meant to be used by templates/macros.
`String` `getCustomClientConfigFactory()`
`CodeGenTemplatesConfig` `getCustomCodeTemplates()`
`String` `getCustomErrorCodeFieldName()`
`String` `getCustomExceptionUnmarshallerImpl()`
`String` `getCustomFileHeader()`
`String` `getCustomResponseMetadataClassName()`
`MetadataConfig` `getCustomServiceMetadata()`
`String` `getCustomServiceNameForRequest()`
`String` `getCustomSignerProvider()`
`Map<String,OperationModifier>` `getOperationModifiers()`
`List<String>` `getOperationsWithResponseStreamContentLengthValidation()`
`String` `getPresignersFqcn()`
`Map<String,String>` `getRenameShapes()`
`String` `getRequestMetrics()`
`String` `getSdkModeledExceptionBaseClassName()`
`Map<String,List<String>>` `getSendEmptyAutoConstructedListAsEmptyList()`
`Map<String,ShapeModifier>` `getShapeModifiers()`
`Map<String,ShapeSubstitution>` `getShapeSubstitutions()`
`Map<String,SimpleMethodFormsWrapper>` `getSimpleMethods()`
`String` `getTransformDirectory()`
`boolean` `isCalculateCRC32FromCompressedData()`
`boolean` `isRequiredParamValidationEnabled()`
`boolean` `isSendExplicitlyEmptyListsForQuery()`
`boolean` `isServiceClientHoldInputStream()`
`boolean` `isSkipInterfaceAdditions()`
`boolean` `isSkipSmokeTests()`
`boolean` `isUseAutoConstructList()`
`boolean` `isUseAutoConstructMap()`
`void` `setAdditionalShapeConstructors(Map<String,ConstructorFormsWrapper> additionalConstructors)`
`void` `setAuthPolicyActions(AuthPolicyActions policyActions)`
`void` `setCalculateCRC32FromCompressedData(boolean calculateCRC32FromCompressedData)`
`void` `setCustomClientConfigFactory(String customClientConfigFactory)`
`void` `setCustomCodeTemplates(CodeGenTemplatesConfig customCodeTemplates)`
`void` `setCustomErrorCodeFieldName(String customErrorCodeFieldName)`
`void` `setCustomExceptionUnmarshallerImpl(String customExceptionUnmarshallerImpl)`
`void` `setCustomFileHeader(String customFileHeader)`
`void` `setCustomResponseMetadataClassName(String customResponseMetadataClassName)`
`void` `setCustomServiceMetadata(MetadataConfig metadataConfig)`
`void` `setCustomServiceNameForRequest(String customServiceNameForRequest)`
`void` `setCustomSignerProvider(String customSignerProvider)`
`void` `setOperationModifiers(Map<String,OperationModifier> operationModifiers)`
`void` `setOperationsWithResponseStreamContentLengthValidation(List<String> operationsWithResponseStreamContentLengthValidation)`
`void` `setPresignersFqcn(String presignersFqcn)`
`void` `setRenameShapes(Map<String,String> renameShapes)`
`void` `setRequestMetrics(String requestMetrics)`
`void` `setRequiredParamValidationEnabled(boolean requiredParamValidationEnabled)`
`void` `setSdkModeledExceptionBaseClassName(String sdkModeledExceptionBaseClassName)`
`void` `setSendEmptyAutoConstructedListAsEmptyList(Map<String,List<String>> sendEmptyAutoConstructedListAsEmptyList)`
`void` `setSendExplicitlyEmptyListsForQuery(boolean sendExplicitlyEmptyListsForQuery)`
`void` `setServiceClientHoldInputStream(boolean serviceClientHoldInputStream)`
`void` `setShapeModifiers(Map<String,ShapeModifier> shapeModifiers)`
`void` `setShapeSubstitutions(Map<String,ShapeSubstitution> shapeSubstitutions)`
`void` `setSimpleMethods(Map<String,SimpleMethodFormsWrapper> simpleMethods)`
`void` `setSkipInterfaceAdditions(boolean skipInterfaceAdditions)`
`void` `setSkipSmokeTests(boolean skipSmokeTests)`
`void` `setStringOverloadForByteBufferMember(StringOverloadForByteBufferMember stringOverloadForByteBufferMember)` Customization to generate a method overload for a member setter that takes a string rather than an ByteBuffer.
`void` `setStringOverloadForInputStreamMember(StringOverloadForInputStreamMember stringOverloadForInputStreamMember)` Customization to generate a method overload for a member setter that takes a string rather than an InputStream.
`CustomizationConfig` `setTransformDirectory(String transformDirectory)`
`void` `setUseAutoConstructList(boolean useAutoConstructList)`
`void` `setUseAutoConstructMap(boolean useAutoConstructMap)`
`void` `setUseModeledOutputShapeNames(boolean useModeledOutputShapeNames)`
`boolean` `useModeledOutputShapeNames()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### DEFAULT

    public static final CustomizationConfig DEFAULT

### Method Detail

#### getRequestMetrics

    public String getRequestMetrics()

#### setRequestMetrics

    public void setRequestMetrics(String requestMetrics)

#### isServiceClientHoldInputStream

    public boolean isServiceClientHoldInputStream()

#### setServiceClientHoldInputStream

    public void setServiceClientHoldInputStream(boolean serviceClientHoldInputStream)

#### getOperationsWithResponseStreamContentLengthValidation

    public List<String> getOperationsWithResponseStreamContentLengthValidation()

#### setOperationsWithResponseStreamContentLengthValidation

    public void setOperationsWithResponseStreamContentLengthValidation(List<String> operationsWithResponseStreamContentLengthValidation)

#### getCustomExceptionUnmarshallerImpl

    public String getCustomExceptionUnmarshallerImpl()

#### setCustomExceptionUnmarshallerImpl

    public void setCustomExceptionUnmarshallerImpl(String customExceptionUnmarshallerImpl)

#### getCustomClientConfigFactory

    public String getCustomClientConfigFactory()

#### setCustomClientConfigFactory

    public void setCustomClientConfigFactory(String customClientConfigFactory)

#### getCustomResponseMetadataClassName

    public String getCustomResponseMetadataClassName()

#### setCustomResponseMetadataClassName

    public void setCustomResponseMetadataClassName(String customResponseMetadataClassName)

#### isSkipInterfaceAdditions

    public boolean isSkipInterfaceAdditions()

#### setSkipInterfaceAdditions

    public void setSkipInterfaceAdditions(boolean skipInterfaceAdditions)

#### getCustomServiceNameForRequest

    public String getCustomServiceNameForRequest()

#### setCustomServiceNameForRequest

    public void setCustomServiceNameForRequest(String customServiceNameForRequest)

#### getCustomCodeTemplates

    public CodeGenTemplatesConfig getCustomCodeTemplates()

#### setCustomCodeTemplates

    public void setCustomCodeTemplates(CodeGenTemplatesConfig customCodeTemplates)

#### getAdditionalShapeConstructors

    public Map<String,ConstructorFormsWrapper> getAdditionalShapeConstructors()

#### setAdditionalShapeConstructors

    public void setAdditionalShapeConstructors(Map<String,ConstructorFormsWrapper> additionalConstructors)

#### getOperationModifiers

    public Map<String,OperationModifier> getOperationModifiers()

#### getRenameShapes

    public Map<String,String> getRenameShapes()

#### setRenameShapes

    public void setRenameShapes(Map<String,String> renameShapes)

#### getSendEmptyAutoConstructedListAsEmptyList

    public Map<String,List<String>> getSendEmptyAutoConstructedListAsEmptyList()

#### setSendEmptyAutoConstructedListAsEmptyList

    public void setSendEmptyAutoConstructedListAsEmptyList(Map<String,List<String>> sendEmptyAutoConstructedListAsEmptyList)

#### setOperationModifiers

    public void setOperationModifiers(Map<String,OperationModifier> operationModifiers)

#### getShapeSubstitutions

    public Map<String,ShapeSubstitution> getShapeSubstitutions()

#### setShapeSubstitutions

    public void setShapeSubstitutions(Map<String,ShapeSubstitution> shapeSubstitutions)

#### getShapeModifiers

    public Map<String,ShapeModifier> getShapeModifiers()

#### setShapeModifiers

    public void setShapeModifiers(Map<String,ShapeModifier> shapeModifiers)

#### getSimpleMethods

    public Map<String,SimpleMethodFormsWrapper> getSimpleMethods()

#### setSimpleMethods

    public void setSimpleMethods(Map<String,SimpleMethodFormsWrapper> simpleMethods)

#### isUseAutoConstructList

    public boolean isUseAutoConstructList()

#### setUseAutoConstructList

    public void setUseAutoConstructList(boolean useAutoConstructList)

#### isUseAutoConstructMap

    public boolean isUseAutoConstructMap()

#### setUseAutoConstructMap

    public void setUseAutoConstructMap(boolean useAutoConstructMap)

#### getAuthPolicyActions

    public AuthPolicyActions getAuthPolicyActions()

#### setAuthPolicyActions

    public void setAuthPolicyActions(AuthPolicyActions policyActions)

#### isRequiredParamValidationEnabled

    public boolean isRequiredParamValidationEnabled()

#### setRequiredParamValidationEnabled

    public void setRequiredParamValidationEnabled(boolean requiredParamValidationEnabled)

#### setStringOverloadForInputStreamMember

    public void setStringOverloadForInputStreamMember(StringOverloadForInputStreamMember stringOverloadForInputStreamMember)

Customization to generate a method overload for a member setter that takes a string rather than an InputStream. Currently only used by Lambda

#### setStringOverloadForByteBufferMember

    public void setStringOverloadForByteBufferMember(StringOverloadForByteBufferMember stringOverloadForByteBufferMember)

Customization to generate a method overload for a member setter that takes a string rather than an ByteBuffer. Currently only used by Lambda

#### getConvenienceTypeOverloads

    public List<ConvenienceTypeOverload> getConvenienceTypeOverloads()

Only meant to be used by templates/macros. When customizing a service use one of the pre-canned options like `setStringOverloadForInputStreamMember(StringOverloadForInputStreamMember)` or `setStringOverloadForByteBufferMember(StringOverloadForByteBufferMember)`

#### getCustomServiceMetadata

    public MetadataConfig getCustomServiceMetadata()

#### setCustomServiceMetadata

    public void setCustomServiceMetadata(MetadataConfig metadataConfig)

#### getCustomErrorCodeFieldName

    public String getCustomErrorCodeFieldName()

#### setCustomErrorCodeFieldName

    public void setCustomErrorCodeFieldName(String customErrorCodeFieldName)

#### useModeledOutputShapeNames

    public boolean useModeledOutputShapeNames()

#### setUseModeledOutputShapeNames

    public void setUseModeledOutputShapeNames(boolean useModeledOutputShapeNames)

#### getSdkModeledExceptionBaseClassName

    public String getSdkModeledExceptionBaseClassName()

#### setSdkModeledExceptionBaseClassName

    public void setSdkModeledExceptionBaseClassName(String sdkModeledExceptionBaseClassName)

#### getCustomSignerProvider

    public String getCustomSignerProvider()

#### setCustomSignerProvider

    public void setCustomSignerProvider(String customSignerProvider)

#### isCalculateCRC32FromCompressedData

    public boolean isCalculateCRC32FromCompressedData()

#### setCalculateCRC32FromCompressedData

    public void setCalculateCRC32FromCompressedData(boolean calculateCRC32FromCompressedData)

#### getCustomFileHeader

    public String getCustomFileHeader()

#### setCustomFileHeader

    public void setCustomFileHeader(String customFileHeader)

#### isSkipSmokeTests

    public boolean isSkipSmokeTests()

#### setSkipSmokeTests

    public void setSkipSmokeTests(boolean skipSmokeTests)

#### isSendExplicitlyEmptyListsForQuery

    public boolean isSendExplicitlyEmptyListsForQuery()

#### setSendExplicitlyEmptyListsForQuery

    public void setSendExplicitlyEmptyListsForQuery(boolean sendExplicitlyEmptyListsForQuery)

#### getPresignersFqcn

    public String getPresignersFqcn()

#### setPresignersFqcn

    public void setPresignersFqcn(String presignersFqcn)

#### getTransformDirectory

    public String getTransformDirectory()

#### setTransformDirectory

    public CustomizationConfig setTransformDirectory(String transformDirectory)